package cn.iocoder.yudao.module.llm.service.modelassesstaskmanual;

import cn.iocoder.yudao.module.llm.controller.admin.modelassesstaskmanual.manualAnnoVo.ManualModelAnnoPageReqVO;
import cn.iocoder.yudao.module.llm.controller.admin.modelassesstaskmanual.manualAnnoVo.ManualModelAnnoSaveReqVO;
import cn.iocoder.yudao.module.llm.dal.dataobject.modelassesstaskmanual.ManualModelAnnoDO;
import cn.iocoder.yudao.module.llm.dal.mysql.modelassesstaskmanual.ManualModelAnnoMapper;
import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;


import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.llm.enums.ErrorCodeConstants.*;

/**
 * 模型评估人工评估标注 Service 实现类
 *
 * @author 华大大模型
 */
@Service
@Validated
public class ManualModelAnnoServiceImpl implements ManualModelAnnoService {

    @Resource
    private ManualModelAnnoMapper manualModelAnnoMapper;

    @Override
    public Long createManualModelAnno(ManualModelAnnoSaveReqVO createReqVO) {
        // 插入
        ManualModelAnnoDO manualModelAnno = BeanUtils.toBean(createReqVO, ManualModelAnnoDO.class);
        manualModelAnnoMapper.insert(manualModelAnno);
        // 返回
        return manualModelAnno.getId();
    }

    @Override
    public void updateManualModelAnno(ManualModelAnnoSaveReqVO updateReqVO) {
        // 校验存在
        validateManualModelAnnoExists(updateReqVO.getId());
        // 更新
        ManualModelAnnoDO updateObj = BeanUtils.toBean(updateReqVO, ManualModelAnnoDO.class);
        manualModelAnnoMapper.updateById(updateObj);
    }

    @Override
    public void deleteManualModelAnno(Long id) {
        // 校验存在
        validateManualModelAnnoExists(id);
        // 删除
        manualModelAnnoMapper.deleteById(id);
    }

    private void validateManualModelAnnoExists(Long id) {
        if (manualModelAnnoMapper.selectById(id) == null) {
            throw exception(MANUAL_MODEL_ANNO_NOT_EXISTS);
        }
    }

    @Override
    public ManualModelAnnoDO getManualModelAnno(Long id) {
        return manualModelAnnoMapper.selectById(id);
    }

    @Override
    public PageResult<ManualModelAnnoDO> getManualModelAnnoPage(ManualModelAnnoPageReqVO pageReqVO) {
        return manualModelAnnoMapper.selectPage(pageReqVO);
    }

}